// defrag

#include "hmalloc.h"
#include "hsamio.h"
#include "hdio.h"
#include "hdstr.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define noupdate 0
#define monitor  1
#define cachesize 15


s_fsam fsam;	// a fsam
s_dir  dir;	  // a dir 
char blankline[] = "                         ";
long disksize, mapsize, freesize, filesize, dirsize, badsize, fragsize, misssize;
long diskcount,mapcount,freecount,filecount,dircount,badcount,fragcount,misscount;
long filenum,fragnum,fsamcount;
s_fsam cache[cachesize]; // a cache of disk sectors
uint   chnext = 0;
long *diradr = 0;

extern void exit(int);
extern char   _argc;
extern void*	_intrv1;
void printat(uint y, uint x);
			
void chwrite(void *ch, long se)
{
	// write to disk cache
  uint idx;

  if (se==0)return;
  for (idx=0;idx<cachesize;idx++)
  {
	  if ((cache[idx].f_myadr == 0) || (cache[idx].f_myadr == se))
	  {
	  	memcpy(&cache[idx],ch,512);
	  	return;
	  }
  }
  memcpy(&cache[chnext],ch,512);
  chnext ++;
  if (chnext >= cachesize) chnext = 0;
}

int chread(void *ch, long se)
{
	// get a sector from the cache or from disk
  uint idx;

  if (se==0) return(error);
  for (idx=0;idx<cachesize;idx++)
  {
	  if (cache[idx].f_myadr == se)
	  {
	  	memcpy(ch,&cache[idx],512);
    	printat(20,12); printf("ch %-7ld",se);
	  	return(ok);
	  }
  }
 return(error);
} 

#if monitor

void monwrite(void *ch, long se)
{
	printat(20,1); printf("wr %-7ld",se);
	hdwrite(ch,se);
	chwrite(ch,se);
	printat(20,1); printf("  ");
}

void monread(void *ch, long se)
{
	if (chread(ch,se) != ok)
	{
  	printat(20,12); printf("rd %-7ld",se);
		hdread(ch,se);
		chwrite(ch,se);
	  printat(20,12); printf("  ");
	}
}

#define hdwrite monwrite
#define hdread  monread
#endif

#if noupdate
#define hdwrite nowrite
void nowrite(void *ch, long se)
{
	ch=ch;
	se=se;
}
#endif

void printat(uint y, uint x)
// possition cursor at col x line y (just like sam basic)
{
	printf("%c%c%c",22,y,x);
}

void pen(uint ink)
// set pen colour 0-15
{
	printf("%c%c",16,ink);
}

void paper(uint p)
// set paper colour 0-15
{
	printf("%c%c",17,p);
}

void percent(long targ, long done)
// print a %age bar at the bottom of the screen to show progress
{
		
	uint pcent,pchar;

	done = (100L * done) / targ;	pcent = done;

	printat(18,1); printf("%3d%% ",pcent);
	printat(18,6); pen(1); paper(15);
  pchar = pcent/4;
  if (pchar) printf("%*.*s",pchar,pchar,blankline);
  pen(7);paper(1);
}

long thingsize(long se)
// se points to the first fsam of a file, avlspace, badsects and
// will return the total number of sectors used by the thing
// as a byproduct diskcount holds the number of areas used
{
	long count;
	uint run;
	count = 0L;
	diskcount = 0L;
	fsamcount = 0L;
	
	do 
	{
		hdread(&fsam, se);
		fsamcount++;  // inc for each fsam
		se = fsam.f_next;
		for (run=0;run<n_run;run++)
		{
			if (fsam.f_runst[run])
			{
				diskcount++;
				count += (fsam.f_runen[run] - fsam.f_runst[ run] +1);
			}
//			printat(21,1); printf("count = %ld ",count);
		}
	} while (se);
	return(count);
}

void buildstats()
// read down the directory building stats for dir, frag, files etc
{
	uint head;
	long se,thisthing,tot,targ;
	
	fragsize=0L; fragcount = 0L; fragnum = 0;
	filesize=0L; filecount = 0L; filenum = 0;
	dirsize=1L;  dircount  = 0L; // label takes up 1 sector 
	badsize=0L;  badcount  = 0L; tot  = 1;
	mapsize=0L;  mapcount  = 0L;

	printat(17,1); printf("Checking Free space chains");
	freesize = thingsize(1L);	freecount = diskcount; mapsize += fsamcount;

	percent(1,0);
	
	printat(17,1); printf("Building disk statistics  ");

	targ = disksize - freesize;
	
	se = 2L;
	do
	{
		hdread (&dir,se);
		dirsize++; tot++;
		if (dir.d_next != (se+1)) dircount++;
		se = dir.d_next;
		for (head=0;head<n_head;head++)
		{
			if (dir.d_head[head].h_fsam) // points to something
			{
				thisthing = thingsize(dir.d_head[head].h_fsam);
				tot += thisthing;
				mapsize += fsamcount;
				switch (dir.d_head[head].h_dir)
				{
					case removed:
					{
						fragnum++;
						fragsize += thisthing; fragcount += diskcount; break;
					}
					case baddir:
					{
						badsize += thisthing; badcount += diskcount; break;
					}
					default :
				  {
					  if (diskcount) filenum ++;
					  filesize += thisthing; filecount += diskcount; 
					}
				}	
    	  percent(targ,tot + mapsize);
			}
		}
	} while (se);
	percent(targ,targ);
}

void unfrag()
// move removed files back to available
{
	long done,se;
	int i;
	s_dir * mydir;
	s_fsam * myavl;

	if (!fragcount) return;

	done = 0L;
	percent(fragnum,done);
	printat(17,1);	printf("Recovering fragmented space");

  if (((mydir  = calloc(1,sizeof(s_fsam))) == 0) 
  ||  ((myavl  = calloc(1,sizeof(s_fsam))) == 0))
  {
	  printf("\rout of memory #1"); exit(0);
  }

  // get last sector of avl chain in memory
  se = AVLSTART;
  do
  {
	  hdread(myavl,se);
	  se = myavl->f_next;
  } while (se);
  
	se = DIRSTART;
	do
	{
		hdread(mydir,se);
		se = mydir->d_next;
		for (i=0;i<n_head;i++)
		{
			if (mydir->d_head[i].h_dir == removed) // found an erased entry
			{
				long prev,thing;

				thing = thingsize(mydir->d_head[i].h_fsam);
				fragsize -= thing;     freesize += thing;
				fragcount-= diskcount; freecount+=diskcount;
				
				// make last free-chain fsam point to erased file fsam
				myavl->f_next  = mydir->d_head[i].h_fsam;
				prev = myavl->f_myadr; // store this adress
				hdwrite(myavl,myavl->f_myadr);
				
				// make erased file fsam point back to free chain
				hdread(myavl,mydir->d_head[i].h_fsam);
				memset(&myavl->f_fib,0,sizeof(s_fib)); 
				myavl->f_prev  = prev;
				hdwrite(myavl,myavl->f_myadr);
				
				// and erase old file dir entry
				mydir->d_head[i].h_dir  = 0;
				mydir->d_head[i].h_fsam = 0;
				memset(mydir->d_head[i].h_name,0,n_name);
				hdwrite(mydir,mydir->d_this);
				done++;
				
				percent(fragnum,done);
			}
		}
	} while (se);
	free(myavl);
	free(mydir);
	percent(fragnum,done);
	
}
uint firstfree(s_fsam * fsam)
// find the first free run entry down a chain
{

	for(;;)
	{
		for (;fsam->f_run<n_run;fsam->f_run++)
		{
			if (!fsam->f_runst[fsam->f_run]) return(ok);
		}
		if (!fsam->f_next) return(error);
		hdread(fsam,fsam->f_next);
		fsam->f_run = 0;
	}
}

uint findnext(s_fsam * fsam)
// find the next used run entry starting from the current fsam/run
{
	for (;;)
	{
		for (;fsam->f_run<n_run;fsam->f_run++)
		{
			if (fsam->f_runst[fsam->f_run]) return(ok);
		}
		if (!fsam->f_next) return(error);
		hdread(fsam,fsam->f_next);
		fsam->f_run=0;
	}
}

uint firstempty(s_fsam * fsam)
// walk a chain to find the first empty fsam
// but never the first fsam
{
	uint run,empty;;

	for(;;)
	{
		if (!fsam->f_next) return(error);
		hdread(fsam,fsam->f_next);
		empty = 1;
		for (run=0;run<n_run;run++)
		{
			if (fsam->f_runst[run]) empty=0;
		}
		if (empty) return(ok);
	}
}

uint findstart(s_fsam * fsam, long adr, long start)
// try and find a run with a start adr = adr
{
	long se;
	uint run;

	se = start;
	do
	{
		hdread(fsam,se);
		for (run=0;run<n_run;run++)
		{
			if (fsam->f_runst[run] == adr) 
			{
				fsam->f_run = run;
				return(ok);
			}
		}
    se = fsam->f_next;
	} while (se);

	se = AVLSTART;
	do
	{
		hdread(fsam,se);
		for (run=0;run<n_run;run++)
		{
			if (fsam->f_runst[run] == adr) 
			{
				fsam->f_run = run;
				return(ok);
			}
		}
    se = fsam->f_next;
	} while (se&&se!=start);
	return(error);
}
		
void compresavl()
// consilodate the avl chain into as few fsam as possible
{
	s_fsam *fsam1,*fsam2;
	long avl1,avl2,targ,actl;
	uint run1,phase1,phase2,phase3,phase4;
	

  if (((fsam1  = calloc(1,sizeof(s_fsam))) == 0) 
  ||  ((fsam2  = calloc(1,sizeof(s_fsam))) == 0))
  {
	  printf("\rout of memory #3"); exit(0);
  }

  targ = freecount;
  actl = targ;
  percent(targ,0);
  do
  {
	  phase4 = 0;

	  // phase 1. move run entries towards the start of the
	  // avl chain so all empty runs are at the end
	  hdread(fsam2,AVLSTART);
	  hdread(fsam1,AVLSTART);
	  fsam1->f_run = fsam2->f_run = 0;
	  firstfree(fsam2);
	  do
	  {
		  phase1 = 0;
		  if (firstfree(fsam1) == ok)
		  {
			  if (findnext(fsam2) == ok)
			  {
				  phase1 = 1;
				  phase4 = 1;
					fsam1->f_runst[fsam1->f_run] = fsam2->f_runst[fsam2->f_run];
					fsam1->f_runen[fsam1->f_run] = fsam2->f_runen[fsam2->f_run];

				  if (fsam1->f_myadr == fsam2->f_myadr)
				  {
					  fsam2->f_runst[fsam1->f_run] = fsam2->f_runst[fsam2->f_run];
					  fsam2->f_runen[fsam1->f_run] = fsam2->f_runen[fsam2->f_run];
						fsam1->f_runst[fsam2->f_run] = 0;
					  fsam1->f_runen[fsam2->f_run] = 0;
				  }
				  else
				  {
					  hdwrite(fsam1,fsam1->f_myadr);
				  }
					fsam2->f_runst[fsam2->f_run] = 0;
				  fsam2->f_runen[fsam2->f_run] = 0;
					hdwrite(fsam2,fsam2->f_myadr);
			  }
		  }
	  } while (phase1);
	  
	  // phase 2. walk the avl chain to find an fsam with no runs 
	  // then fix up the fsams on either side
	  // find the first free run and make a single sector entry there
	  // return to the top of the loop and do it agian until no more are left
	  hdread(fsam1,AVLSTART);
	  hdread(fsam2,AVLSTART); 
	  fsam2->f_run=0; avl1=AVLSTART;
	  if (firstfree(fsam2) == ok) avl1=fsam2->f_myadr;
	  do
	  {
		  phase2 = 0;
		  if (firstempty(fsam1) == ok)
		  {
			  phase2=1;
			  phase3=1;
			  // fix prev fsam
			  if (fsam1->f_prev)
			  {
				  hdread(fsam2,fsam1->f_prev);
				  fsam2->f_next = fsam1->f_next;
				  hdwrite(fsam2,fsam2->f_myadr);
			  }
			  if (fsam1->f_next)
			  {
				  hdread(fsam2,fsam1->f_next);
				  fsam2->f_prev = fsam1->f_prev;
				  hdwrite(fsam2,fsam2->f_myadr);
			  }
			  hdread(fsam2,avl1);
			  fsam2->f_run=0;
			  if (firstfree(fsam2) == ok)
			  {
			  	fsam2->f_runst[fsam2->f_run] = 
			  	fsam2->f_runen[fsam2->f_run] = fsam1->f_myadr;
			  	hdwrite(fsam2,fsam2->f_myadr);
			  	freesize++; mapsize--; targ++; actl++;
			  }
			  else // avl chain is full so put empty fsam back
			  {
				  phase2=0;
				  if (fsam1->f_prev)
				  {
					  hdread(fsam2,fsam1->f_prev);
					  fsam2->f_next = fsam1->f_myadr;
					  hdwrite(fsam2,fsam2->f_myadr);
				  }
				  if (fsam1->f_next)
				  {
					  hdread(fsam2,fsam1->f_next);
					  fsam2->f_prev = fsam1->f_myadr;
					  hdwrite(fsam2,fsam2->f_myadr);
				  }
			  }
		  }
	  } while (phase2);
	  if (phase3) phase4=1;
	  
	  // phase 3. get the first run entry then walk the entire avl chain
	  // to see if it is contigious with any other. If so extend the 
	  // first found and destroy the second found.
	  // repeat until nothing has been moved
    do
	  {
		  phase3=0;
		  avl2 = AVLSTART;
		  do
		  {
			  hdread(fsam1,avl2);
			  for (run1=0;run1<n_run;run1++)
			  {
				  if (fsam1->f_runen[run1])
				  {
					  if (findstart(fsam2,fsam1->f_runen[run1]+1,fsam1->f_myadr) == ok)
					  {
							fsam1->f_runen[run1] = fsam2->f_runen[fsam2->f_run];

						  if (fsam1->f_myadr == fsam2->f_myadr)
						  {
							  fsam2->f_runen[run1] = fsam2->f_runen[fsam2->f_run];
						  	fsam1->f_runst[fsam2->f_run] =
							  fsam1->f_runen[fsam2->f_run] = 0;
						  }
						  else 
						  {
							  hdwrite(fsam1,fsam1->f_myadr);
						  }
						  fsam2->f_runst[fsam2->f_run] =
						  fsam2->f_runen[fsam2->f_run] = 0;
						  hdwrite(fsam2,fsam2->f_myadr);
						  phase3=1;
						  phase4=1;
						  actl--;
						  percent(targ,targ-actl);
					  }
				  }
			  }
			  avl2=fsam1->f_next;
		  } while (avl2);
	  } while(phase3);
	  
	  // phase4. go back to phase 1 and repeat all phases until nothing 
	  // moves at all
	freesize = thingsize(1L);	freecount = diskcount;
  } while (phase4);
  percent(targ,targ);
  
	free(fsam1);
	free(fsam2);
}

void builddirarray()
{
	long se,*dp;
  s_dir *dir;
  	
	free(diradr);
  if ((dir  = calloc(1,sizeof(s_dir))) == 0) 
  {
	  printf("\rout of memory #4"); exit(0);
  }

  if ((diradr  = calloc(dircount,sizeof(long))) == 0) 
  {
	  printf("\rout of memory #5"); exit(0);
  }
	
	se = DIRSTART;
	dp = diradr;
	do
	{
		hdread(dir,se);
		*dp = se;
		dp++;
		se = dir->d_next;
	} while (se);
	
	free(dir);
}

int readdir(s_dir *dir, s_fhead *ch, long idx)
{
	long tmp;

  tmp =  idx % n_head;
	idx /= n_head;

	if (idx >= dircount) return(error);

	hdread(dir,diradr[idx]);
	memcpy(ch,&dir->d_head[tmp],sizeof(s_fhead));
	return(ok);

}

int writedir(s_dir *dir, s_fhead *ch, long idx)
{
	long tmp;

  tmp =  idx % n_head;
	idx /= n_head;

	if (idx >= dircount) return(error);

	hdread(dir,diradr[idx]);
	memcpy(&dir->d_head[tmp],ch,sizeof(s_fhead));
	hdwrite(dir,diradr[idx]);
	return(ok);
}

void joindirtoavl()
{
	s_fsam * fsam;
	s_dir  * dir;
	long se,prev;

  if ((dir  = calloc(1,sizeof(s_dir))) == 0) 
  {
	  printf("\rout of memory #8"); exit(0);
  }
  if ((fsam  = calloc(1,sizeof(s_fsam))) == 0) 
  {
	  printf("\rout of memory #9"); exit(0);
  }

  se = AVLSTART;
  do
  {
	  hdread(fsam,se);
	  se = fsam->f_next;
  } while (se);

  se = DIRSTART;
  do
  {
	  hdread(dir,se);
	  if (dir->d_head[0].h_fsam == 0) goto join1;
	  prev=se;
	  se=dir->d_next;
  } while (se);

  return; // there are no empty directory sectors

join1:  

  // terminate the dir chain
  hdread(dir,prev);
  dir->d_next = 0;
  hdwrite(dir,prev);

  //attach to end of avl chain
  fsam->f_next = se;
  hdwrite(fsam,fsam->f_myadr);

  // fix pointers to new end of avl chain
  prev = fsam->f_myadr;
  do
  {
	  hdread(fsam,se);
	  fsam->f_prev=prev;
	  hdwrite(fsam,se);
	  prev=se;
	  se=fsam->f_next;
  } while (se);

  free(dir);
  free(fsam);
	
}

int dircomp(s_fhead *head1,s_fhead *head2)
{
	// return -1 if head1<head2
	// return 0  if head1=head2
	// return 1  if head1>head2
	// definition of < = > depends on sort spec to be defined
  // needs working on
  
	if (head1->h_fsam == 0)
	{ 
		if (head2->h_fsam == 0) return(0);
		else return(-1);
	}
	else
	{
		if (head2->h_fsam == 0) return(1);
	}
	return(0);
}

		
void compressdir()
{
	s_fhead *head1,*head2,*head3;
	long  idx1,idx2,targ;
	int   rdx1,rdx2;
	s_dir *dir;
	
	builddirarray();
	targ = dircount * n_head;
	percent(targ,0);

  if ((dir  = calloc(1,sizeof(s_dir))) == 0) 
  {
	  printf("\rout of memory #6"); exit(0);
  }

  if (((head1  = calloc(1,sizeof(s_fhead))) == 0)
  ||  ((head2  = calloc(1,sizeof(s_fhead))) == 0))
  
  {
	  printf("\rout of memory #7"); exit(0);
  }

  // first compress the directory
  idx1=0;
  do // find first blank entry
  {
	  rdx1=readdir(dir,head1,idx1++);
  } while ((rdx1==ok) && (head1->h_fsam));
  
  idx1--;
  idx2=idx1; //idx1 & 2 point to first blank entry

  for (;rdx1==ok;idx1++) //if no blank entries then this is skipped
  {
	  // find next blank entry
	  rdx1=readdir(dir,head1,idx1);
	  if (rdx1==ok) // not at the end yet
	  if (head1->h_fsam == 0) // entry is blank
	  {
		  do // find first non blank entry
		  {
			  rdx2=readdir(dir,head2,idx2++);
		  } while ((rdx2==ok) && (head2->h_fsam==0));
		  
		  idx2--;
		  if (rdx2 == ok) // not at the end so must point to a non blank header
		  {
			  head3 = head1; head1 = head2; head2 = head3; // swap em
			  writedir(dir,head1,idx1); // update directories
			  writedir(dir,head2,idx2); //   ""      ""
		  }
		  else
		  {
			  rdx1=error; // there are no more non blank entries
		  }
	  }
	  percent(targ,idx1);
  }
  percent(targ,targ);
	free(head1);
	free(head2);
	free(head3);
	free(diradr);
	free(dir);
	joindirtoavl();
}

void dgetarg(char* cmd)
{
	// get one string off the sam stack into my heap
	// cmd must be big enough or you will crash
#asm
	push iy
	push de ; save address of cmd
	call 0x124
	call 0x12a
	ex de,hl	; hl-> start of string	
	pop de		; de -> cmd
	ldir		; bc already had length
	pop iy
#endasm
}

void do_a() // get disk size
{
	disksize = (long)hdmaxtrk * (long)hdmaxhead * (long)hdmaxsect;
}
void do_b() // build stats 
{
	buildstats();
}
void do_c() // unfrag 
{
	unfrag();
}
void do_d() // compress aval chain
{
	compresavl();
}
void do_e() // display disk name
{
  printf("%19.19s",(char*)&fsam);
}
void do_f() // print disk size
{
	printf("%ldKb",disksize/2);
}
void do_g() //read disk label
{
  hdread(&fsam,0);
}
void do_h() //
{
	printf("%ldKb",freesize/2L);
}
void do_i() //
{
	printf("%ld",freecount);
}
void do_j() //
{
	printf("%ldKb",filesize/2L);
}
void do_k() //
{
	printf("%ld",filecount);
}
void do_l() //
{
	printf("%ld",filenum);
}
void do_m() //
{
  printf("%ldKb",dirsize/2L);
}
void do_n() //
{
  printf("%ld",dircount);
}
void do_o() //
{
	printf("%ldKb",mapsize/2L);
}
void do_p() //
{
	printf("%ldKb",badsize/2L);
}
void do_q() //
{
	printf("%ld",badcount);
}
void do_r() //
{
	misssize = disksize - (mapsize + fragsize + filesize + dirsize + badsize + freesize);
	printf("%ld",misssize/2L);
}
void do_s() //
{
	printf("%ldKb",fragsize/2L);
}
void do_t() //
{
	printf("%ld",fragcount);
}
void do_u() //
{
	compressdir();
}
void do_v() //
{
}
void do_w() //
{ 
}
void do_x() //
{
}
void do_y() //
{
}
void do_z() //
{
}

void intr1()
{
	char cmd[4];

	if (_argc != 0)
	 {
	  dgetarg(cmd);
	  switch (cmd[0])
	  {


		  case 'a': do_a(); break; // get disk size
		  case 'b': do_b(); break; // build stats
		  case 'c': do_c(); break; // unfrag
 		  case 'd': do_d(); break; // compress avl chain
 		  case 'e': do_e(); break; // display disk name
 		  case 'f': do_f(); break; // display disk size
 		  case 'g': do_g(); break; // read disk label 
		  case 'h': do_h(); break; // print freesize
		  case 'i': do_i(); break; // print freecount
		  case 'j': do_j(); break; // print filesize
		  case 'k': do_k(); break; // print filecount
		  case 'l': do_l(); break; // print filenum
		  case 'm': do_m(); break; // print dirsize
		  case 'n': do_n(); break; // print dircount
		  case 'o': do_o(); break; // print mapsize
		  case 'p': do_p(); break; // print badsize
		  case 'q': do_q(); break; // print badcount
		  case 'r': do_r(); break; // print misssize
		  case 's': do_s(); break; // print fragsize
		  case 't': do_t(); break; // print fragcount
 		  case 'u': do_u(); break; // compress directory
 		  case 'v': do_v(); break; // 
 		  case 'w': do_w(); break; // 
 		  case 'x': do_x(); break; // 
 		  case 'y': do_y(); break; // 
 		  case 'z': do_z(); break; // 
	  }
	 } 
}

void main()
{
	_intrv1 = intr1;	// vector intr1
	hdinit();
	memset(&cache[0],0,cachesize*sizeof(s_fsam));
}








