;
;
; Runtime startoff module Z80 compiler.  Sam Coupe 
;
;	Software S D Software 1995
;
; $Log:	zcrt.as,v $
;
	psect	text,		class=CODE
	psect	vectors,	class=CODE
	psect	strings,	class=CODE
	psect	const,		class=CODE
	psect   im2vecs,	class=CODE
	psect	baseram,	class=DATA
	psect	data,		class=DATA
	psect	bss,		class=DATA
	psect	stack,		class=DATA
	psect	ramstart,	class=DATA
	psect	heap,		class=DATA
	psect	nvram,		class=DATA

	psect	text

	global	start, 	_main, 		_exit,	  __Hbss, 	__Lbss
	global  __argc, __intrv1, 	__intrv2, __intrv3, __intrv4
	global  __hook,	__UFIA
		
; ORG Should always be at 0x8000
	
	defb	0c3h		; JP opcode
	defw	start		; cannot be optimized by ZAS -J option
	defb	0c3h
	defw	intr1		; jump to intr1
	defb	0c3h
	defw    intr2		; jump to intr2
	defb	0c3h
	defw	intr3		; jump to intr3
	defb	0c3h
	defw    intr4		; jump to intr4

__samsp:defw    0		; store sams stack pointer
__argc:	defb    0		; number of arguments passed
__hook: defb    0		; hook code being worked on
__UFIA: defw    0       ; ufia passed in
;
savestk:
	ld hl,(__samsp) ; get old stack pointer value
	ex (sp),hl		; and put it on the stack
	push ix			; save ix & iy for return to sam
	push iy			;
	ld (__samsp),sp ; save current stack pointer
	ld (__argc),a	; store a reg for later use
	jp (hl)			; return
;
intr1:				; interupt 1 routine
	call savestk
	defb	0cdh
__intrv1:
	defw	_exit;		; set this to actual intrupt routine
	jr _exit
;
;
;	
intr2:				; interupt 2 routine
	call savestk
	defb	0cdh
__intrv2:
	defw	_exit;		; set this to actual intrupt routine
	jr _exit
;
;
;	
intr3:				; interupt 3 routine
	call savestk
	defb	0cdh
__intrv3:
	defw	_exit;		; set this to actual intrupt routine
	jr _exit
;
;
;	
intr4:				; interupt 4 routine
	call savestk
	ld a,e		    ; get hook code
	ld (__hook),a	; save it

	ld (__UFIA),ix  ; make UFIA point to ix
;	ld de,__UFIA	; copy ufia up to hdos
;	push ix
;	pop hl
;	ld bc,80
;	ldir

	defb	0cdh
__intrv4:
	defw	_exit;		; set this to actual intrupt routine
	jr _exit
	
start:	
	call savestk
	ld	de,__Lbss	;Start of BSS segment
	or	a		;clear carry
	ld	hl,__Hbss
	sbc	hl,de		;size of uninitialized data area
	ld	c,l
	ld	b,h
	dec	b,c	
	ld	l,e
	ld	h,d
	inc	de
	ld	(hl),0
 	ldir			;clear memory
	
	call	_main		
	signat	_exit,4152
_exit:
	ld 	sp,(__samsp)	; restore sams stack pointer
	pop iy				; recover iy & ix
	pop ix				;
	pop hl				; get previous stack pointer
	ld (__samsp),hl		; and put it back into samsp
	ret
	
	end	start

