
#include "hdstr.h"
#include <string.h>

const char wild1 = '?';
const char wild2 = '*';
const char dirsep = '/';
const char blank[11] = "          ";

// **************************************************************************
// file name handling routines
// **************************************************************************

void padname(char *s1)
// append spaces to s1 until it is length of namelength
// must be able to hold 11 cahrs or else !
{
 for(;;)
 {
  if ((strlen(s1) >= namelen)) return;
  strcat(s1," ");
 }
}

int filenamecmp(char* s1, char *s2)
// testok 23/9/95
// compare two file names return error if they do not match
// return ok if they do
// s2 may contain ? and * as wildcards
// typically s1 is read from the directory and s2 isn't
{
 uint i;

 for (i=0;i<10;i++)
 {
  if ((*s1 == *s2) || (*s2 == wild1))
  {
   if (*s1 == 0) return(ok);	  
   s1++;
   s2++;
  }
  else
  {
   if (*s2 == wild2) return(ok);
   else return(error);
  }
 }
 return(ok);
}

int filenametest(char* s1)
// testok 23/9/95
// test a file name to see if it is valid
// it won't be if it has a / ? or * in it
// return ok if good error if bad
{
 uint i;
 for (i=0;i<10;i++)
 {
  if ((*s1 == dirsep) || (*s1 == wild2) || (*s1 == wild1))
   return(error);
  if (*s1 == 0) return(ok);
  s1++;
 }
 return(ok);
}


char filepart[15];

char *getfilepart(char *path)
// given a null terminated path return a pointer to the file part
{
 char *pp;
 
 memset(filepart,0,sizeof(filepart));
 pp = strrchr(path,dirsep);
 if (pp == 0) pp = path; else pp++;
 strncpy(filepart,pp,14);
 padname(filepart);
 return(filepart);
}

// **************************************************************************
// end of file name handling routines
// **************************************************************************
